package turbowin;


import java.awt.Color;
import javax.swing.JOptionPane;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Martin
 */
final public class WOW_APR_settings extends javax.swing.JFrame {

   /**
    * Creates new form WOW_settings
    */
   public WOW_APR_settings() {
      initComponents();
      initComponents2();
      setLocation(main.x_pos_main_frame, main.y_pos_main_frame);
   }

   /**
    * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
    * Editor.
    */
   @SuppressWarnings("unchecked")
   // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
   private void initComponents()
   {

      buttonGroup2 = new javax.swing.ButtonGroup();
      buttonGroup3 = new javax.swing.ButtonGroup();
      buttonGroup4 = new javax.swing.ButtonGroup();
      buttonGroup5 = new javax.swing.ButtonGroup();
      jButton1 = new javax.swing.JButton();
      jButton2 = new javax.swing.JButton();
      jSeparator1 = new javax.swing.JSeparator();
      jPanel3 = new javax.swing.JPanel();
      jCheckBox2 = new javax.swing.JCheckBox();
      jPanel4 = new javax.swing.JPanel();
      jRadioButton6 = new javax.swing.JRadioButton();
      jRadioButton7 = new javax.swing.JRadioButton();
      jRadioButton8 = new javax.swing.JRadioButton();
      jLabel11 = new javax.swing.JLabel();
      jPanel5 = new javax.swing.JPanel();
      jLabel8 = new javax.swing.JLabel();
      jTextField4 = new javax.swing.JTextField();
      jLabel13 = new javax.swing.JLabel();
      jLabel9 = new javax.swing.JLabel();
      jTextField5 = new javax.swing.JTextField();
      jLabel12 = new javax.swing.JLabel();
      jLabel15 = new javax.swing.JLabel();
      jLabel16 = new javax.swing.JLabel();
      jLabel3 = new javax.swing.JLabel();
      jLabel4 = new javax.swing.JLabel();
      jPanel6 = new javax.swing.JPanel();
      jPanel7 = new javax.swing.JPanel();
      jRadioButton9 = new javax.swing.JRadioButton();
      jRadioButton10 = new javax.swing.JRadioButton();
      jRadioButton11 = new javax.swing.JRadioButton();
      jCheckBox3 = new javax.swing.JCheckBox();
      jLabel7 = new javax.swing.JLabel();
      jLabel17 = new javax.swing.JLabel();
      jPanel8 = new javax.swing.JPanel();
      jPanel9 = new javax.swing.JPanel();
      jRadioButton12 = new javax.swing.JRadioButton();
      jRadioButton1 = new javax.swing.JRadioButton();
      jCheckBox4 = new javax.swing.JCheckBox();
      jLabel18 = new javax.swing.JLabel();
      jLabel19 = new javax.swing.JLabel();
      jPanel1 = new javax.swing.JPanel();
      jCheckBox1 = new javax.swing.JCheckBox();
      jPanel2 = new javax.swing.JPanel();
      jRadioButton2 = new javax.swing.JRadioButton();
      jRadioButton3 = new javax.swing.JRadioButton();
      jRadioButton4 = new javax.swing.JRadioButton();
      jLabel1 = new javax.swing.JLabel();

      setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
      setTitle("AP[&T]R and AWSR settings");
      setMinimumSize(new java.awt.Dimension(1000, 700));
      setResizable(false);

      jButton1.setText("OK");
      jButton1.addActionListener(new java.awt.event.ActionListener()
      {
         public void actionPerformed(java.awt.event.ActionEvent evt)
         {
            OK_button_actionPerformed(evt);
         }
      });

      jButton2.setText("Cancel");
      jButton2.addActionListener(new java.awt.event.ActionListener()
      {
         public void actionPerformed(java.awt.event.ActionEvent evt)
         {
            Cancel_button_actionPerformed(evt);
         }
      });

      jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
      jPanel3.setPreferredSize(new java.awt.Dimension(400, 383));

      jCheckBox2.setText("report pressure [& temp] automatically (barometer* + GPS)");
      jCheckBox2.setActionCommand("");

      jPanel4.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
      jPanel4.setPreferredSize(new java.awt.Dimension(340, 93));

      buttonGroup2.add(jRadioButton6);
      jRadioButton6.setText("1 hour");

      buttonGroup2.add(jRadioButton7);
      jRadioButton7.setText("3 hours");

      buttonGroup2.add(jRadioButton8);
      jRadioButton8.setText("6 hours ");
      jRadioButton8.setActionCommand("6 hours");

      javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
      jPanel4.setLayout(jPanel4Layout);
      jPanel4Layout.setHorizontalGroup(
         jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel4Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jRadioButton6)
            .addGap(60, 60, 60)
            .addComponent(jRadioButton7)
            .addGap(60, 60, 60)
            .addComponent(jRadioButton8)
            .addContainerGap(47, Short.MAX_VALUE))
      );
      jPanel4Layout.setVerticalGroup(
         jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel4Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jRadioButton6)
               .addComponent(jRadioButton7)
               .addComponent(jRadioButton8))
            .addContainerGap())
      );

      javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
      jPanel3.setLayout(jPanel3Layout);
      jPanel3Layout.setHorizontalGroup(
         jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel3Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
               .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, 360, Short.MAX_VALUE)
               .addComponent(jCheckBox2, javax.swing.GroupLayout.DEFAULT_SIZE, 360, Short.MAX_VALUE))
            .addContainerGap(65, Short.MAX_VALUE))
      );
      jPanel3Layout.setVerticalGroup(
         jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel3Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jCheckBox2)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap())
      );

      jLabel11.setText("AP[&T]R (Automated Pressure [& Temperature] Reports)");

      jPanel5.setBorder(javax.swing.BorderFactory.createEtchedBorder());

      jLabel8.setText("normal steaming draft (metres, e.g. 12.6)");

      jLabel13.setText("[0.0 - 50.0]");

      jLabel9.setText("barometer instrument correction** (hPa, e.g. -0.1)");

      jLabel12.setText("[-4.0 - 4.0]");

      jLabel15.setText("** average over the whole calibration range (this is NOT the height corr)");

      javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
      jPanel5.setLayout(jPanel5Layout);
      jPanel5Layout.setHorizontalGroup(
         jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel5Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jLabel9)
               .addComponent(jLabel8))
            .addGap(18, 18, 18)
            .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jTextField5, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jTextField4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jLabel12)
               .addComponent(jLabel13))
            .addGap(18, 18, 18)
            .addComponent(jLabel15, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)
            .addContainerGap())
      );
      jPanel5Layout.setVerticalGroup(
         jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel5Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jLabel8)
               .addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel13))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jLabel9)
               .addComponent(jTextField5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel12)
               .addComponent(jLabel15))
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
      );

      jLabel16.setText("AP[&T]R");

      jLabel3.setForeground(java.awt.Color.blue);
      jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel3.setText("--- minimise TurboWin+ after AP[&T]R or AWSR settings are set ---");

      jLabel4.setForeground(java.awt.Color.blue);
      jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel4.setText("--- enable TurboWin+ autostart to continue automatic reporting after a computer restart ---");

      jPanel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());
      jPanel6.setPreferredSize(new java.awt.Dimension(384, 95));

      jPanel7.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
      jPanel7.setPreferredSize(new java.awt.Dimension(360, 42));

      buttonGroup3.add(jRadioButton9);
      jRadioButton9.setText("1 hour");
      jRadioButton9.setPreferredSize(new java.awt.Dimension(75, 23));

      buttonGroup3.add(jRadioButton10);
      jRadioButton10.setText("3 hours ");
      jRadioButton10.setPreferredSize(new java.awt.Dimension(75, 23));

      buttonGroup3.add(jRadioButton11);
      jRadioButton11.setText("6 hours");
      jRadioButton11.setPreferredSize(new java.awt.Dimension(75, 23));

      javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
      jPanel7.setLayout(jPanel7Layout);
      jPanel7Layout.setHorizontalGroup(
         jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel7Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jRadioButton9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(45, 45, 45)
            .addComponent(jRadioButton10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(60, 60, 60)
            .addComponent(jRadioButton11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
      );
      jPanel7Layout.setVerticalGroup(
         jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel7Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jRadioButton9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jRadioButton10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jRadioButton11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addContainerGap())
      );

      jCheckBox3.setText("report all measured data automatically (AWS connected)");

      javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
      jPanel6.setLayout(jPanel6Layout);
      jPanel6Layout.setHorizontalGroup(
         jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel6Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, 348, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jCheckBox3, javax.swing.GroupLayout.PREFERRED_SIZE, 342, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addContainerGap(26, Short.MAX_VALUE))
      );
      jPanel6Layout.setVerticalGroup(
         jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jCheckBox3)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap())
      );

      jLabel7.setText("AWSR (Automatic Weather Station Reports)");

      jLabel17.setText("* recommended: static head or flexible tube or WiFi sensor to measure outside pressure");

      jPanel8.setBorder(javax.swing.BorderFactory.createEtchedBorder());

      jPanel9.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
      jPanel9.setPreferredSize(new java.awt.Dimension(360, 42));

      buttonGroup4.add(jRadioButton12);
      jRadioButton12.setText("Server Met Center*");

      buttonGroup4.add(jRadioButton1);
      jRadioButton1.setText("Custom email**");

      javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
      jPanel9.setLayout(jPanel9Layout);
      jPanel9Layout.setHorizontalGroup(
         jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel9Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jRadioButton12)
            .addGap(60, 60, 60)
            .addComponent(jRadioButton1)
            .addContainerGap(61, Short.MAX_VALUE))
      );
      jPanel9Layout.setVerticalGroup(
         jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel9Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jRadioButton12)
               .addComponent(jRadioButton1))
            .addContainerGap())
      );

      jCheckBox4.setText("do not upload if ship speed < 0.5 knot (port mode option)");

      javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
      jPanel8.setLayout(jPanel8Layout);
      jPanel8Layout.setHorizontalGroup(
         jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel8Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jCheckBox4, javax.swing.GroupLayout.PREFERRED_SIZE, 360, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addContainerGap(61, Short.MAX_VALUE))
      );
      jPanel8Layout.setVerticalGroup(
         jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel8Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addComponent(jCheckBox4)
            .addContainerGap(11, Short.MAX_VALUE))
      );

      jLabel18.setText("AP[&T]R / AWSR send (upload) method");

      jLabel19.setText("* Maintenance -> Server settings         ** Maintenance -> Email settings");

      jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
      jPanel1.setPreferredSize(new java.awt.Dimension(384, 95));

      jCheckBox1.setText("pop-up screen");

      jPanel2.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
      jPanel2.setPreferredSize(new java.awt.Dimension(360, 42));

      buttonGroup5.add(jRadioButton2);
      jRadioButton2.setText("1 hour");
      jRadioButton2.setPreferredSize(new java.awt.Dimension(75, 23));

      buttonGroup5.add(jRadioButton3);
      jRadioButton3.setText("3 hours");
      jRadioButton3.setPreferredSize(new java.awt.Dimension(75, 23));

      buttonGroup5.add(jRadioButton4);
      jRadioButton4.setText("6 hours");
      jRadioButton4.setPreferredSize(new java.awt.Dimension(75, 23));

      javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
      jPanel2.setLayout(jPanel2Layout);
      jPanel2Layout.setHorizontalGroup(
         jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel2Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jRadioButton2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(45, 45, 45)
            .addComponent(jRadioButton3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(60, 60, 60)
            .addComponent(jRadioButton4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap(8, Short.MAX_VALUE))
      );
      jPanel2Layout.setVerticalGroup(
         jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jRadioButton2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jRadioButton3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jRadioButton4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addContainerGap())
      );

      javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
      jPanel1.setLayout(jPanel1Layout);
      jPanel1Layout.setHorizontalGroup(
         jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel1Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jCheckBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 326, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 348, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addContainerGap(26, Short.MAX_VALUE))
      );
      jPanel1Layout.setVerticalGroup(
         jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel1Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jCheckBox1)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap())
      );

      jLabel1.setText("AP[&T]R / AWS reminder visual observation");

      javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
      getContentPane().setLayout(layout);
      layout.setHorizontalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addGroup(layout.createSequentialGroup()
                  .addContainerGap()
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                     .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                     .addComponent(jSeparator1)
                     .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
               .addGroup(layout.createSequentialGroup()
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                     .addGroup(layout.createSequentialGroup()
                        .addGap(400, 400, 400)
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE))
                     .addGroup(layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                           .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                           .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                              .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                 .addGroup(layout.createSequentialGroup()
                                    .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addGap(42, 42, 42))
                                 .addGroup(layout.createSequentialGroup()
                                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, 435, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                              .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                 .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                 .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                           .addGroup(layout.createSequentialGroup()
                              .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                              .addGap(104, 104, 104))
                           .addGroup(layout.createSequentialGroup()
                              .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                 .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, 350, javax.swing.GroupLayout.PREFERRED_SIZE)
                                 .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 263, javax.swing.GroupLayout.PREFERRED_SIZE)
                                 .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                 .addComponent(jLabel19, javax.swing.GroupLayout.PREFERRED_SIZE, 431, javax.swing.GroupLayout.PREFERRED_SIZE))
                              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                              .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                 .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                 .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))))
                  .addGap(55, 55, 55)))
            .addContainerGap())
      );
      layout.setVerticalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addGap(26, 26, 26)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jLabel11)
               .addComponent(jLabel7))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
               .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, 95, Short.MAX_VALUE)
               .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel17)
            .addGap(55, 55, 55)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jLabel18)
               .addComponent(jLabel1))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel19)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 59, Short.MAX_VALUE)
            .addComponent(jLabel16)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(51, 51, 51)
            .addComponent(jLabel3)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel4)
            .addGap(18, 18, 18)
            .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(15, 15, 15)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGap(15, 15, 15))
      );

      pack();
   }// </editor-fold>//GEN-END:initComponents

   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void initComponents2()
   {
      // initialise
      jCheckBox1.setSelected(false);         // pop-up screen 
      jCheckBox2.setSelected(false);         // APR  
      jCheckBox3.setSelected(false);         // AWSR
      jCheckBox4.setSelected(false);         // port mode option[true/false]; do not upload if ship speed < 1 knot 
      jRadioButton6.setSelected(false);
      jRadioButton7.setSelected(false);
      jRadioButton8.setSelected(false);
      jRadioButton9.setSelected(false);
      jRadioButton10.setSelected(false);
      jRadioButton11.setSelected(false);
      jRadioButton12.setSelected(false);
      //jRadioButton13.setSelected(false);
      //jRadioButton14.setSelected(false);
      //jRadioButton15.setSelected(false);
      jRadioButton1.setSelected(false);
      
      jTextField4.setText("");
      jTextField5.setText("");
      
      
      // put back earlier inserted values (if applicable)
      //
      
      // AP[&T]R (Automated Pressure [&Temperature] Reports)
      if (main.APR == true) 
      {
         jCheckBox2.setSelected(true);
      } 
      
      // AP[&T]R reporting(upload)interval
      if (main.APR_reporting_interval.equals("1"))
      {
         jRadioButton6.setSelected(true);
      }
      else if (main.APR_reporting_interval.equals("3"))
      {
         jRadioButton7.setSelected(true);
      }
      else if (main.APR_reporting_interval.equals("6"))
      {
         jRadioButton8.setSelected(true);
      }
      

      // AWSR (Automatic Weather Station Reports)
      if (main.AWSR == true) 
      {
         jCheckBox3.setSelected(true);
      } 

      // AWSR reporting(upload)interval                         // NOT FOR EUCAWS + 'uploads via eucaws iridium modem'(but yes for EUCAWS + 'turbowin upload method')
      if (main.AWSR_reporting_interval.equals("1"))
      {
         jRadioButton9.setSelected(true);
      }
      else if (main.AWSR_reporting_interval.equals("3"))
      {
         jRadioButton10.setSelected(true);
      }
      else if (main.AWSR_reporting_interval.equals("6"))
      {
         jRadioButton11.setSelected(true);
      }
      
      
      // AP[&T]R / AWSR send method
      if (main.APTR_AWSR_send_method.equals(main.APTR_AWSR_SERVER))
      {
         jRadioButton12.setSelected(true);
      }
      //else if (main.APTR_AWSR_send_method.equals(main.APTR_AWSR_SMTP_HOST))       // will not reach this branch from version 4.2, see Function meta_data_from_configuration_regels_into_global_vars() [main.java]
      //{
      //   jRadioButton13.setSelected(true);
      //}
      //else if (main.APTR_AWSR_send_method.equals(main.APTR_AWSR_GMAIL))           // will not reach this branch from version 4.2, see Function meta_data_from_configuration_regels_into_global_vars() [main.java]         
      //{
      //   jRadioButton14.setSelected(true);
      //}
      //else if (main.APTR_AWSR_send_method.equals(main.APTR_AWSR_YAHOO_MAIL))      // will not reach this branch from version 4.2, see Function meta_data_from_configuration_regels_into_global_vars() [main.java]
      //{
      //   jRadioButton15.setSelected(true);
      //}
      else if (main.APTR_AWSR_send_method.equals(main.APTR_AWSR_CUSTOM_MAIL))
      {
         jRadioButton1.setSelected(true);
      }
      
      // port mode option (deactivate APR/AWSR if ship speed is minimal (e.g. < 1 knot/< 0.5 knots)
      if (main.port_mode_option == true)
      {
         jCheckBox4.setSelected(true);
      }
      
      // pop-up dashboard
      if (main.pop_up_screen == true)                                     // if (main.pop_up_dashboard == true)
      {
         jCheckBox1.setSelected(true);
      }
      
      // pop-up dasboard interval
      if (main.pop_up_screen_interval.equals("1"))                        // if (main.pop_up_dashboard_interval.equals("1"))
      {
         jRadioButton2.setSelected(true);
      }
      else if (main.pop_up_screen_interval.equals("3"))                   // else if (main.pop_up_dashboard_interval.equals("3"))
      {
         jRadioButton3.setSelected(true);
      }
      else if (main.pop_up_screen_interval.equals("6"))                   // else if (main.pop_up_dashboard_interval.equals("6"))
      {
         jRadioButton4.setSelected(true);
      }
   
      
      // common AP[&T]R and AWSR average draught
      jTextField4.setText(main.WOW_APR_average_draught);
      
      // common AP[&T]R and AWSR barometer instrument correction (note: can also be set in the barometer reading input screen)
      jTextField5.setText(main.barometer_instrument_correction);
      
      
      // disable AWSR in case of EUCAWS + 'uploads via eucaws iridium modem' (but not if EUCAWS + 'turbowin uploads method')
      if ( (main.RS232_connection_mode == 3) && (main.eucaws_uploads_method.equals(main.UPLOADS_VIA_EUCAWS) || main.eucaws_uploads_method.equals("")) )       // EUCAWS connected + eucaws iridium modem upload method 
      {
         // reset
         jCheckBox3.setSelected(false);
         jRadioButton9.setSelected(false);
         jRadioButton10.setSelected(false);
         jRadioButton11.setSelected(false);

         // disable
         jCheckBox3.setEnabled(false);
         jRadioButton9.setEnabled(false);
         jRadioButton10.setEnabled(false);
         jRadioButton11.setEnabled(false);
         jLabel7.setEnabled(false);
      } // if (main.RS232_connection_mode == 3)
      
      
      // disable send method if no (email settings))data available
      //
      // Email APR/APTR send method
      if ( (main.obs_email_recipient.equals("")) || (main.obs_email_subject.equals("")) )
      {
         // [ALL]           // NB the Email basics are these two items (recipient and subject) that must be present always 
         //jRadioButton13.setEnabled(false);                                    // SMTP host
         //jRadioButton14.setEnabled(false);                                    // GMail
         //jRadioButton15.setEnabled(false);                                    // Yahoo Mail
         
         jRadioButton1.setSelected(false);                                    // Custom Mail
         jRadioButton1.setEnabled(false);                                     // Custom Mail
      }
      else // recipient and subject ok
      {
         // [FORMAT 101]
         if (main.obs_format.equals(main.FORMAT_101))
         {
            if (main.obs_101_email.equals(""))                                // obs_101_email: body or attachment
            {
               //jRadioButton13.setEnabled(false);                              // SMTP host send method
               //jRadioButton14.setEnabled(false);                              // GMail send method
               //jRadioButton15.setEnabled(false);                              // Yahoo Mail send method
               
               jRadioButton1.setSelected(false);                                // Custom Mail
               jRadioButton1.setEnabled(false);                                 // Custom Mail
            }
         } // if (obs_format.equals(main.FORMAT_101))
         
         // [SMTP HOST]
         //if ( (main.local_email_server.equals("")) || (main.your_ship_address.equals("")) )
         //{
         //   jRadioButton13.setEnabled(false);                                 // SMTP host send method   
         //}
         
         // [GMAIl]
         //if ( (main.your_gmail_address.equals("")) || (main.gmail_app_password.equals("")) || (main.gmail_security.equals("")) )
         //{
         //   jRadioButton14.setEnabled(false);                                // GMail send method
         //}
         
         // [YAHOO]
         //if ( (main.your_yahoo_address.equals("")) || (main.yahoo_app_password.equals("")) || (main.yahoo_security.equals("")) )
         //{
         //   jRadioButton15.setEnabled(false);                                // Yahoo Mail send method
         //}
         
         // [CUSTOM]
         if ( (main.your_custom_address.equals("")) || (main.custom_password.equals("")) || (main.custom_security.equals("")) || (main.custom_port.equals("")) || (main.custom_email_server.equals("")))
         {
            jRadioButton1.setSelected(false);                                // Custom Mail
            jRadioButton1.setEnabled(false);                                 // Custom Mail send method
         }
         
      } // else (recipient and subject ok)
      
      // APR/APTR via Server; check if upload URL was entered 
      if ( (main.upload_URL.equals("") || main.upload_URL == null) )
      {
         // no upload URL entered
         jRadioButton12.setSelected(false);                                   // server send method
         jRadioButton12.setEnabled(false);                                    // Server send method       
      }
      
      // disable checkbox "do not upload if ship speed < 1 knot" if no APR/AWSR send/upload method available
      if ((jRadioButton12.isEnabled() == false) && (jRadioButton1.isEnabled() == false))
      {
         jCheckBox4.setSelected(false);                                       // do not upload if ship speed < 1 knot
         jCheckBox4.setEnabled(false);                                        // do not upload if ship speed < 1 knot
      }
   }
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void OK_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OK_button_actionPerformed
      // TODO add your handling code here:
      
      // initialisation
      checks_ok = true;
      boolean additional_APR_checks_ok = true;
      boolean additional_AWSR_checks_ok = true;
      Reset_All_WOW_Vars();                                        // WOW was removed from version 4.2 (so this is to be sure that the "remains" are set to default)
      
      
      ////////////// read the inserted/checked values ////////////
      //
      
      // AP[&T]R reporting
      main.APR = jCheckBox2.isSelected() == true;
              
      // AP[&T]R upload interval
      if (jRadioButton6.isSelected())
      {
         main.APR_reporting_interval = "1";
      }
      else if (jRadioButton7.isSelected())
      {
         main.APR_reporting_interval = "3";
      }   
      else if (jRadioButton8.isSelected())
      {
         main.APR_reporting_interval = "6";
      }   
      

      // AWSR reporting
      main.AWSR = jCheckBox3.isSelected() == true;
              
      // AWSR upload interval
      if (jRadioButton9.isSelected())
      {
         main.AWSR_reporting_interval = "1";
      }
      else if (jRadioButton10.isSelected())
      {
         main.AWSR_reporting_interval = "3";
      }   
      else if (jRadioButton11.isSelected())
      {
         main.AWSR_reporting_interval = "6";
      }   

      // AP(T)R and AWSR send method
      if (jRadioButton12.isSelected())
      {
         main.APTR_AWSR_send_method = main.APTR_AWSR_SERVER;
      }
      //else if (jRadioButton13.isSelected())
      //{
      //   main.APTR_AWSR_send_method = main.APTR_AWSR_SMTP_HOST;
      //}
      //else if (jRadioButton14.isSelected())
      //{
      //   main.APTR_AWSR_send_method = main.APTR_AWSR_GMAIL;
      //}
      //else if (jRadioButton15.isSelected())
      //{
      //   main.APTR_AWSR_send_method = main.APTR_AWSR_YAHOO_MAIL;
      //}
      else if (jRadioButton1.isSelected())
      {
         main.APTR_AWSR_send_method = main.APTR_AWSR_CUSTOM_MAIL;
      }    
      
      // port mode option [true/false]; AP(T)R and AWSR deactivate APR/AWSR if ship speed is minimal 
      main.port_mode_option = jCheckBox4.isSelected() == true;
      
      // pop-up screen (dashboard) while in APR / AWS mode
      //
      // NB from version 4.3 RC2 pop-up dashboard was replaced by pop-up screen. But the source code for the pop-up dashboard is still available
      //    only the triggers/var's on this settings form are changed from 'pop_up_dashboard' to 'pop_up_screen' and 'pop_up_dashboard_interval' to 'pop_up_screen_interval
      //    so it will be easy to activate the pop-up dashboard again
      //
      main.pop_up_screen = jCheckBox1.isSelected() == true;       // main.pop_up_dashboard = jCheckBox1.isSelected() == true;
      
      // pop-up dashboard interval
      if (jRadioButton2.isSelected())
      {
         main.pop_up_screen_interval = "1";                       // main.pop_up_dashboard_interval = "1";
      }
      else if (jRadioButton3.isSelected()) 
      {
         main.pop_up_screen_interval = "3";                       // main.pop_up_dashboard_interval = "3";
      }
      else if (jRadioButton4.isSelected())
      {
         main.pop_up_screen_interval = "6";                       // main.pop_up_dashboard_interval = "6";
      }
      
      // common AP[&T]R /*and AWSR*/ average draught
      main.WOW_APR_average_draught = jTextField4.getText().trim(); 
      
      // common AP[&T]R /*and AWSR*/ barometeter instrument correction (note this can also be set in the barometer reading input page)
      main.barometer_instrument_correction = jTextField5.getText().trim(); 
      
      
      ///////////////// checking AP[&T]R inserted data ////////////
      //
      if ((main.APR == true) && checks_ok)          // so AP[&T]R reporting requested
      {
         // AP[&T]R reporting interval
         if (checks_ok && main.APR_reporting_interval.equals(""))
         {
            JOptionPane.showMessageDialog(null, "AP[&T]R reporting interval not selected", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
            Reset_All_APR_Vars();                   // checks_ok will be set in this function also                           
         }
      } // if ((main.APR == true) && checks_ok)  
      

      ///////////////// checking pop-up screen (dashboard) ////////////
      //
      if ((main.pop_up_screen == true) && checks_ok)                              // if ((main.pop_up_dashboard == true) && checks_ok)
      {
         // pop-up interval
         if (checks_ok && main.pop_up_screen_interval.equals(""))                  // if (checks_ok && main.pop_up_dashboard_interval.equals(""))
         {
            JOptionPane.showMessageDialog(null, "AP[&T]R / AWS screen pop-up interval not selected", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
            Reset_All_pop_up_screen_Vars();                                        // Reset_All_pop_up_dashboard_Vars();
         }
      }
      

      ///////////////// checking AWSR inserted data ////////////
      //
      if ((main.AWSR == true) && checks_ok)          // so AWS reporting requested
      {
         // AWSR reporting interval
         if (checks_ok && main.AWSR_reporting_interval.equals(""))
         {
            JOptionPane.showMessageDialog(null, "AWSR reporting interval not selected", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
            Reset_All_AWSR_Vars();                     // checks_ok will be set in this function also                           
         }
      } // if ((main.APR == true) && checks_ok)  

      
      /////////////// AP[&T]R and AWSR can't be checked both at the same time ////////
      if ((main.APR == true && main.AWSR == true) && checks_ok) 
      {
         JOptionPane.showMessageDialog(null, "AP[&T]R AND AWSR reporting can't be checked both at one time", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
         Reset_All_APR_Vars();                      // checks_ok will be set in this function also      
         Reset_All_AWSR_Vars();                     // checks_ok will be set in this function also
      }
      
      //////// APR/APTR or AWSR then the send method must be known //////
      if ((main.APR == true || main.AWSR == true) && (main.APTR_AWSR_send_method.equals("")) && checks_ok)
      {
         JOptionPane.showMessageDialog(null, "AP[&T]R / AWSR send method unknown", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
         Reset_All_APR_Vars();                      // checks_ok will be set in this function also      
         Reset_All_AWSR_Vars();                     // checks_ok will be set in this function also
      }
      
      
      //////////// pop-up screen interval >= APR reporting interval ///////
      if (main.APR == true)
      {
         int int_popup_screen_interval = 0;                                                    // int int_popup_dashboard_interval = 0;
         try
         {        
            int_popup_screen_interval = Integer.parseInt(main.pop_up_screen_interval);         // int_popup_dashboard_interval = Integer.parseInt(main.pop_up_dashboard_interval);
         }
         catch (NumberFormatException e)
         {
            int_popup_screen_interval = 0;                                                      // int_popup_dashboard_interval = 0;   
         }
         
         int int_APR_reporting_interval = 0;
         try
         {        
            int_APR_reporting_interval = Integer.parseInt(main.APR_reporting_interval);
         }
         catch (NumberFormatException e)
         {
            int_APR_reporting_interval = 0;        
         }         
         
         if ((int_popup_screen_interval != 0) && (int_APR_reporting_interval != 0))           // so valid values // if ((int_popup_dashboard_interval != 0) && (int_APR_reporting_interval != 0)) 
         {
            if (int_popup_screen_interval < int_APR_reporting_interval)                       // if (int_popup_dashboard_interval < int_APR_reporting_interval)
            {
               JOptionPane.showMessageDialog(null, "pop-up screen interval must be greather than or equal to AP[&T]R reporting interval", main.APPLICATION_NAME + " warning", JOptionPane.WARNING_MESSAGE);
               Reset_All_pop_up_screen_Vars();                                                 // Reset_All_pop_up_dashboard_Vars();
            }
         }
      } // if (main.APR == true)
      
      
      //////////// pop-up screen interval >= AWSR reporting interval ///////
      if (main.AWSR == true)
      {
         int int_popup_screen_interval = 0;                                                      // int int_popup_dashboard_interval = 0;
         try
         {        
            int_popup_screen_interval = Integer.parseInt(main.pop_up_screen_interval);           // int_popup_dashboard_interval = Integer.parseInt(main.pop_up_dashboard_interval);
         }
         catch (NumberFormatException e)
         {
            int_popup_screen_interval = 0;                                                       //  int_popup_dashboard_interval = 0;      
         }
         
         int int_AWSR_reporting_interval = 0;
         try
         {        
            int_AWSR_reporting_interval = Integer.parseInt(main.AWSR_reporting_interval);
         }
         catch (NumberFormatException e)
         {
            int_AWSR_reporting_interval = 0;        
         }         
         
         if ((int_popup_screen_interval != 0) && (int_AWSR_reporting_interval != 0))    // so valid values //  if ((int_popup_dashboard_interval != 0) && (int_AWSR_reporting_interval != 0))
         {
            if (int_popup_screen_interval < int_AWSR_reporting_interval)                      // if (int_popup_dashboard_interval < int_AWSR_reporting_interval)
            {
               JOptionPane.showMessageDialog(null, "pop-up screen interval must be greather than or equal to AWSR reporting interval", main.APPLICATION_NAME + " warning", JOptionPane.WARNING_MESSAGE);
               Reset_All_pop_up_screen_Vars();                                                // Reset_All_pop_up_dashboard_Vars();
            }
         }
      } // if (main.APR == true)
      
      
      //////// EUCAWS and 'AWSR + uploads via eucaws' cannot be checked together  (but EUCAWS + 'AWSR + uploads via turbowin is ok) /////
      if ( (main.RS232_connection_mode == 3) && (main.AWSR == true) && checks_ok && (main.eucaws_uploads_method.equals(main.UPLOADS_VIA_EUCAWS)) )
      {
         //JOptionPane.showMessageDialog(null, "EUCAWS AWS device has its own send provision; AWSR settings ignored", main.APPLICATION_NAME + " warning", JOptionPane.WARNING_MESSAGE);
         JOptionPane.showMessageDialog(null, "EUCAWS AWS uploads method was set to EUCAWS iridium modem (Maintenance -> obs format sretting), no AWSR possible ; AWSR settings ignored", main.APPLICATION_NAME + " warning", JOptionPane.WARNING_MESSAGE);
         main.AWSR = false;
      }
      
      
      //////////// checking AP[&T]R-AWSR inserted data //////////////
      //
      if ((main.WOW || main.APR) && checks_ok)
      {
         // AP[&T]R /*and AWSR*/ draught
         try
         {
            double double_WOW_APR_average_draught = Double.parseDouble(main.WOW_APR_average_draught);
               
            if (main.WOW_APR_average_draught.equals("") || !(double_WOW_APR_average_draught >= 0 && double_WOW_APR_average_draught <= 50))
            {
               JOptionPane.showMessageDialog(null, "normal steaming draft not in range 0.0 - 50.0", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
               Reset_All_common_WOW_APR_AWSR_Vars();     // checks_ok will be set in this function also 
            }
         }
         catch (NumberFormatException e) 
         {
            JOptionPane.showMessageDialog(null, "normal steaming draft not in range 0.0 - 50.0", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
            Reset_All_common_WOW_APR_AWSR_Vars();     // checks_ok will be set in this function also  
         }    
         
         ////////// AP[&T]R /*and AWSR*/ barometer ic /////////
         if (checks_ok)                               // because it could be set to false in Function Reset_All_common_WOW_APR_AWSR_Vars() [see above]
         {
            try
            {
               double double_barometer_instrument_correction = Double.parseDouble(main.barometer_instrument_correction.trim());
             
               if (main.barometer_instrument_correction.equals("") || !(double_barometer_instrument_correction >= -4.0 || double_barometer_instrument_correction <= 4.0))
               {
                  JOptionPane.showMessageDialog(null, "barometer instrument correction not in range -4.0 - 4.0", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
                  Reset_All_common_WOW_APR_AWSR_Vars();     // checks_ok will be set in this function also  
               }             
            }
            catch (NumberFormatException e) 
            { 
               JOptionPane.showMessageDialog(null, "barometer_instrument_correction not in range -4.0 - 4.0", main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
               Reset_All_common_WOW_APR_AWSR_Vars();     // checks_ok will be set in this function also  
            }  
         } // if (checks_ok)
      } // if ((main.WOW || main.APR) && checks_ok)
      
      
      //////////// checking upload (AP[&T]R)URL (can't be set on this page but useful to remind the observer //////////////
      //
      //if (checks_ok)
      //{
      //   if (main.APR && main.upload_URL.equals(""))
      //   {
      //      // it's only a reminder, so never resetting var's
      //      JOptionPane.showMessageDialog(null, "Do not forget to insert the upload URL (select: Maintenance -> Server settings)", main.APPLICATION_NAME + " reminder", JOptionPane.INFORMATION_MESSAGE);
      //      //.....
      //   }
      //} // if (checks_ok)
      
      
      ///////////// save the new settings and close the input screen /////////////
      //
      if (checks_ok)
      {
         //if (main.offline_mode_via_cmd == true)     // after installation as standalone program this will always be the case
         //{
          //  main.schrijf_configuratie_regels();          
         //}
         //else // so offline_via_jnlp mode or online (webstart) mode
         //{
         //   main.set_muffin();
         //   main.schrijf_configuratie_regels();
         //
         
         // message 
         //String info = "Changes will take effect inmediatelly. Not necessary to restart";
         //JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " info", JOptionPane.INFORMATION_MESSAGE);            
            
         // close this WOW/APR settings input page 
         setVisible(false);
         dispose();         
         
         // extra check message boxes!!
         if (main.APR)
         {
            additional_APR_checks_ok = APR_additional_requirements_checks();
         }
         if (main.AWSR)
         {
            additional_AWSR_checks_ok = AWSR_additional_requirements_checks();
         }    
         
         if (additional_APR_checks_ok == false)
         {
            Reset_All_APR_Vars();
         }
         if (additional_AWSR_checks_ok == false)
         {
            Reset_All_AWSR_Vars();
         }
         
         
         if (!main.APR)
         {
            // NB reset JLabel39 (e.g. in APR mode: "--- more than 30 minutes to go for next automated upload, please do not insert observation data --- "
            //    must be reseted to original string
            main.jLabel39.setForeground(Color.BLACK);
            main.jLabel39.setText("--- adding data: input menu, popup menu, toolbar icons or click on the text labels or fields ---");
         }
   
      } // if (checks_ok)
      
      
      if (checks_ok && additional_APR_checks_ok && additional_AWSR_checks_ok)
      {
         // clear the text fields on the main screen (because maybe there are still values in the text fields from a previous setting eg APR = true) and enable the output menu items again
         main.Reset_all_meteo_parameters(); 
         
         if (main.offline_mode_via_cmd == true)     // after installation as standalone program this will always be the case
         {
            main.schrijf_configuratie_regels();          
         }
         else // so offline_via_jnlp mode or online (webstart) mode
         {
            main.schrijf_configuratie_regels();
         }   
      } // if (checks_ok && additional_APR_checks_ok && additional_AWSR_checks_ok && additional_WOW_checks_ok)
      
      
      // always (nevermind checks_ok == true etc.)
      main.disable_and_enable_output_menu_items();   // in fact also for ENABLING the output menu options if now set APR = false and in in earlier stage APR = true
      main.set_APR_toolbar();               // invokes indirect also APR_toolbar_itemStateCanged() [main.java] 
      main.set_AWSR_toolbar();              // invokes indirect also AWSR_toolbar_itemStateCanged() [main.java] 

   }//GEN-LAST:event_OK_button_actionPerformed

   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   public static boolean APR_additional_requirements_checks()
   {
      // called from: - OK_button_actionPerformed() [WOW_APR_settings.java]
      //              - APR_toolbar_itemStateChanged [main.java]
      //
      // NB see also: RS232_check_APR_settings() [main_RS232_RS422.java]
      
      String info = "";
      boolean additional_APR_requirements_ok;
      
      
      // Barometer connected?
      if (main.RS232_connection_mode == 0 || main.RS232_connection_mode == 3 || main.RS232_connection_mode == 9 || main.RS232_connection_mode == 10)   // 0 = no instrument connected, 3 or 9 or 10 = AWS connected
      {
         info = "[APR] Barometer connection unknown (select: Maintenance -> Serial/USB/LAN device settings)"; 
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }        
           
      // GPS connected?      
      if (main.RS232_GPS_connection_mode == 0)                                  // 0 no GPS connected
      {
         info = "[APR] GPS connection unknown (select: Maintenance -> Serial/USB/LAN device settings)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }
   
      // call sign
      //if (main.call_sign.trim().equals("") == true || main.call_sign.trim().length() < 2)
      //{
      //   info = "[APR] Call sign unknown (select: Maintenance -> Station data)";
      //   JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      //}
      
      // station ID
      if (main.station_ID.trim().equals("") == true || main.station_ID.trim().length() < 2)
      {
         info = "[APR] station ID unknown (select: Maintenance -> Station data)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }
      
      // height barometer
      if (main.barometer_above_sll.trim().equals("") == true || main.barometer_above_sll.trim().length() < 1)
      {
         info = "[APR] Height of the barometer above SLL unknown (select: Maintenance -> Station data)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }
      if (main.keel_sll.trim().equals("") == true || main.keel_sll.trim().length() < 1)
      {
         info = "[APR] Distance of bottom of the keel to SLL unknown (select: Maintenance -> Station data)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }

      // logs folder        
      if (main.logs_dir.trim().equals("") == true || main.logs_dir.trim().length() < 2)
      {
         info = "[APR] Logs folder unknown (select: Maintenance -> Log files settings)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }
   
      // obs format
      if (main.obs_format.equals(main.FORMAT_101) == false && main.obs_format.equals(main.FORMAT_FM13) == false)
      {
         info = "[APR] In APR mode the obs format must be '101' or FM13 (select: Maintenance -> Obs format setting)"; 
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }     
      
      
      if (info.equals("") == false)                    // 1 or more warning messages were given            
      {
         additional_APR_requirements_ok = false;
      }
      else
      {
         additional_APR_requirements_ok = true;
      }
      
      
      return additional_APR_requirements_ok;
   
   }
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   public static boolean AWSR_additional_requirements_checks()
   {
      // called from: OK_button_actionPerformed() [WOW_APR_settings.java]
      //
      // NB see also: RS422_check_AWSR_settings() [main_RS232_RS422.java]
      
      String info = "";
      boolean additional_AWSR_requirements_ok;
      
      
      // AWS connected? (not for EUCAWS + 'eucaws iridium modem uploads method' but yes for EUCAWS + 'turbowin uploads method')
      if (main.RS232_connection_mode != 9 && main.RS232_connection_mode != 10 && main.RS232_connection_mode != 3)   // 9 or 10 = OMC 140 AWS connected; 3 = EUCAWS connected
      {
         info = "[AWSR] AWS connection unknown (select: Maintenance -> Serial/USB/LAN device settings)"; 
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }        
      
           
      // GPS connected?      
      //if (main.RS232_GPS_connection_mode == 0)                                  // 0 no GPS connected
      //{
      //   info = "[AWSR] GPS connection unknown (select: Maintenance -> Serial/USB/LAN connection settings)";
      //   JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      //}
   
      // call sign
      //if (main.call_sign.trim().equals("") == true || main.call_sign.trim().length() < 2)
      //{
      //   info = "[AWSR] Call sign unknown (select: Maintenance -> Station data)";
      //   JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      //}
      
      // station ID
      if (main.station_ID.trim().equals("") == true || main.station_ID.trim().length() < 2)
      {
         info = "[AWSR] station ID unknown (select: Maintenance -> Station data)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }
   
      // height barometer
      if (main.barometer_above_sll.trim().equals("") == true || main.barometer_above_sll.trim().length() < 1)
      {
         info = "[AWSR] Height of the barometer above SLL unknown (select: Maintenance -> Station data)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }
      if (main.keel_sll.trim().equals("") == true || main.keel_sll.trim().length() < 1)
      {
         info = "[AWSR] Distance of bottom of the keel to SLL unknown (select: Maintenance -> Station data)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }

      // logs folder        
      if (main.logs_dir.trim().equals("") == true || main.logs_dir.trim().length() < 2)
      {
         info = "[AWSR] Logs folder unknown (select: Maintenance -> Log files settings)";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }
   
      // obs format
      //if (main.obs_format.equals(main.FORMAT_101) == false)
      //{
      //   info = "[AWSR] In AWSR mode the obs format must be '101' (select: Maintenance -> Obs format setting)"; 
      //   JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      //}            
      if ( (main.obs_format.equals(main.FORMAT_FM13) == false) && (main.obs_format.equals(main.FORMAT_101) == false) && 
         (main.eucaws_uploads_method.equals(main.UPLOADS_VIA_TURBOWIN) == false) )
      {
         // NB AWS mode is always reporting with format101
         info = "[AWSR] In AWSR mode the obs format must be FM13 or 101 or 'AWS + uploads via TurboWin+' (select: Maintenance -> Obs format setting)"; 
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " please do not forget", JOptionPane.INFORMATION_MESSAGE);
      }            

      
      if (info.equals("") == false)                    // 1 or more warning messages were given            
      {
         additional_AWSR_requirements_ok = false;
      }
      else
      {
         additional_AWSR_requirements_ok = true;
      }
      
      
      return additional_AWSR_requirements_ok;
   }
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   private void Reset_All_WOW_Vars()
   {
      //checks_ok                           = false;
      
      main.WOW                            = false;      // yes or no publish on WOW (WeatherObservationsWebsite)
      main.WOW_site_id                    = "";
      main.WOW_site_pin                   = "";
      main.WOW_reporting_interval         = "";
      //main.WOW_average_height_barometer   = "";   
   }
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   private void Reset_All_pop_up_screen_Vars()                                  // private void Reset_All_pop_up_dashboard_Vars()
   {
      // pop-up screen used by APR and AWS
      checks_ok                            = false;
      main.pop_up_screen                = false;                                // main.pop_up_dashboard                = false;
      main.pop_up_screen_interval       = "";                                   //  main.pop_up_dashboard_interval       = "";
   }
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   private void Reset_All_APR_Vars()
   {
      checks_ok                           = false;
      
      main.APR                            = false;      // yes or no send automated pressure reports
      main.APR_reporting_interval         = "";
      main.APTR_AWSR_send_method          = "";
   }
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   private void Reset_All_AWSR_Vars()
   {
      checks_ok                            = false;
      
      main.AWSR                            = false;      // yes or no send automated AWS reports (not for EuCAWS)
      main.AWSR_reporting_interval         = "";
      main.APTR_AWSR_send_method           = "";
   }
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   private void Reset_All_common_WOW_APR_AWSR_Vars()
   {
      checks_ok                            = false;
      
      main.WOW_APR_average_draught         = "";         // NB also used by AWSR  
      main.barometer_instrument_correction = "";
   }
 
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void Cancel_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Cancel_button_actionPerformed
      // TODO add your handling code here:
      
      setVisible(false);
      dispose();      
   }//GEN-LAST:event_Cancel_button_actionPerformed

   
   
   /**
    * @param args the command line arguments
    */
   public static void main(String args[]) {
      /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
       * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
       */
      try {
         for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
            if ("Nimbus".equals(info.getName())) {
               javax.swing.UIManager.setLookAndFeel(info.getClassName());
               break;
            }
         }
      } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
         java.util.logging.Logger.getLogger(WOW_APR_settings.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
      }
      //</editor-fold>
      //</editor-fold>
      
        //</editor-fold>
        //</editor-fold>

      /* Create and display the form */
      java.awt.EventQueue.invokeLater(new Runnable() {
         @Override
         public void run() {
            new WOW_APR_settings().setVisible(true);
         }
      });
   }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.ButtonGroup buttonGroup2;
   private javax.swing.ButtonGroup buttonGroup3;
   private javax.swing.ButtonGroup buttonGroup4;
   private javax.swing.ButtonGroup buttonGroup5;
   private javax.swing.JButton jButton1;
   private javax.swing.JButton jButton2;
   private javax.swing.JCheckBox jCheckBox1;
   private javax.swing.JCheckBox jCheckBox2;
   private javax.swing.JCheckBox jCheckBox3;
   private javax.swing.JCheckBox jCheckBox4;
   private javax.swing.JLabel jLabel1;
   private javax.swing.JLabel jLabel11;
   private javax.swing.JLabel jLabel12;
   private javax.swing.JLabel jLabel13;
   private javax.swing.JLabel jLabel15;
   private javax.swing.JLabel jLabel16;
   private javax.swing.JLabel jLabel17;
   private javax.swing.JLabel jLabel18;
   private javax.swing.JLabel jLabel19;
   private javax.swing.JLabel jLabel3;
   private javax.swing.JLabel jLabel4;
   private javax.swing.JLabel jLabel7;
   private javax.swing.JLabel jLabel8;
   private javax.swing.JLabel jLabel9;
   private javax.swing.JPanel jPanel1;
   private javax.swing.JPanel jPanel2;
   private javax.swing.JPanel jPanel3;
   private javax.swing.JPanel jPanel4;
   private javax.swing.JPanel jPanel5;
   private javax.swing.JPanel jPanel6;
   private javax.swing.JPanel jPanel7;
   private javax.swing.JPanel jPanel8;
   private javax.swing.JPanel jPanel9;
   private javax.swing.JRadioButton jRadioButton1;
   private javax.swing.JRadioButton jRadioButton10;
   private javax.swing.JRadioButton jRadioButton11;
   private javax.swing.JRadioButton jRadioButton12;
   private javax.swing.JRadioButton jRadioButton2;
   private javax.swing.JRadioButton jRadioButton3;
   private javax.swing.JRadioButton jRadioButton4;
   private javax.swing.JRadioButton jRadioButton6;
   private javax.swing.JRadioButton jRadioButton7;
   private javax.swing.JRadioButton jRadioButton8;
   private javax.swing.JRadioButton jRadioButton9;
   private javax.swing.JSeparator jSeparator1;
   private javax.swing.JTextField jTextField4;
   private javax.swing.JTextField jTextField5;
   // End of variables declaration//GEN-END:variables


   private boolean checks_ok                                   = true;
}
